<?php
    require_once("../../php/db_utils.php");
    
    try {
        // Connect to the database
        $database = db_connect();
        
        // Incoming data
        $currentTag = $_POST["tag"];
        $canvasId = $_POST["canvas_id"];
        $username = $_POST["username"];
        
        // Declare query (Get similar tags that don't belong to the active canvas and belong to either public canvases or canvases belonging to the active user)
        $query = 'SELECT tags.tag, tags.description, tags.canvas_id, canvas.canvas_name
                  FROM tags
                  INNER JOIN canvas ON tags.canvas_id = canvas.canvas_id
                  WHERE NOT tags.canvas_id = "' . $canvasId . '"
                  AND (canvas.canvas_public = 1
                  OR (tags.canvas_id IN (SELECT canvas_id FROM canvas WHERE user_id = "' . $username . '")))
                  ORDER BY tag;';
                    
        // Run query
        $recordSet = db_query_return($database, $query);
        
        // Get similar tags
        $tags = Array();
        
        $index = 0;
        
        while($record = $recordSet->fetch_assoc()) {
            $percentage;
            
            similar_text($currentTag, $record["tag"], $percentage);
            
            if($percentage > 75) {
                $tags[$index]["tag"] = $record["tag"];
                $tags[$index]["description"] = $record["description"];
                $tags[$index]["canvas_id"] = $record["canvas_id"];
                $tags[$index]["canvas_name"] = $record["canvas_name"];
                $tags[$index]["percentage"] = $percentage;
                $index++;
            }
        }
        
        // Sort tags by relevance
        function sortByRelevance($a, $b) {
            return $b["percentage"] - $a["percentage"];
        }
        
        usort($tags, "sortByRelevance");
        
        mysqli_free_result($recordSet);
        
        echo(json_encode($tags));
        
        // Close the connection to the database
        db_close($database);
    }
    catch(Exception $e) {
        $errorMsg = $e->getMessage();
        print_r($errorMsg);
    }
?>